#ifndef TRACKWATCHER_H
#define TRACKWATCHER_H

// main class, derive from MWindow
#include "MWindow.h"
#include "pluginproto.h"
#include "MTextView.h"
#include "VGroup.h"
#include "Looper.h"


class LoggerWindow: public MWindow
{   
	public:
		LoggerWindow(SoundPlayController *);
		virtual ~LoggerWindow();
		virtual void MessageReceived(BMessage *mes);
		virtual bool QuitRequested();
		virtual void Show();
		virtual void ExecuteAndLog();
		SoundPlayController *ctrl;
		class Tasker *worker;
		
	private:
		MTextView *tv;
		MTextView *cv;
		void LogMessage(const char *message, uint32 colorid, int32 page);
		BMessageRunner *runner;
};

class ConfigView: public VGroup
{
	public:
		ConfigView(BMessage *_config);
		virtual ~ConfigView();
		virtual void MessageReceived(BMessage *mes);

	private:
		BMessage *config;
};

class Tasker: public BLooper
{
public:
	Tasker(LoggerWindow *winptr,const char *name, int32 priority, int32 portCapacity);
	virtual ~Tasker(void);
	virtual void MessageReceived(BMessage *mes);

private:
	const char *command;
	LoggerWindow *gWinPtr;

};


#endif